config/routes.rb
# encoding: utf-8
#
Rails.application.routes.draw do
  root to: "home#index"

  # News
  resources :sections, only: [:index, :show]
  get "/news" => "news#index", as: "news_index"
  resources :news, only: [:show, :new, :create]
  get "/redirect/:id" => "links#show"
  get "/:year/:month/:day" => "news#calendar", year: /(19|20)\d{2}/, month: /[01]?\d/, day: /[0-3]?\d/

  # Diaries & Users
  resources :users, only: [:show] do
    resources :journaux, controller: "diaries", as: "diaries", except: [:index, :new, :create] do
      member do
        post :convert
        post :move
      end
    end
    resources :liens, controller: "bookmarks", as: "bookmarks", except: [:index, :new, :create]
    member do
      get :news
      get :journaux
      get :liens
      get :posts
      get :suivi
      get :comments
      get :wiki
    end
  end
  resources :journaux, controller: "diaries", as: "diaries", only: [:index, :new, :create]
  resources :liens, controller: "bookmarks", as: "bookmarks", only: [:index, :new, :create]

  # Forums
  resources :forums, only: [:index, :show] do
    resources :posts, except: [:new, :create]
  end
  resources :posts, only: [:new, :create]

  # Other contents
  resources :sondages, controller: "polls", as: "polls", except: [:edit, :update, :destroy] do
    member { post :vote }
  end
  resources :suivi, controller: "trackers", as: "trackers" do
    collection { get :comments }
  end
  resources :wiki, controller: "wiki_pages", as: "wiki_pages" do
    collection do
      get "pages" => :pages
      get "modifications" => :changes
    end
    member do
      get "/revisions/:revision" => :revision, as: :revision
    end
  end

  # Nodes
  get "/tableau-de-bord" => "dashboard#index", as: :dashboard
  get "/tableau-de-bord/reponses" => "dashboard#answers"
  get "/comments/:id(,:d)(.html)" => "comments#templeet"
  resources :nodes, only: [] do
    resources :comments do
      member do
        get :answer
        post "/relevance/for",     controller: "relevances", action: :for
        post "/relevance/against", controller: "relevances", action: :against
      end
    end
    resources :tags, only: [:new, :create, :update, :destroy]
    member do
      post "/vote/for",     controller: "votes", action: :for
      post "/vote/against", controller: "votes", action: :against
    end
  end
  resources :readings, only: [:index, :destroy]
  delete "readings" => "readings#destroy_all"
  resources :tags, only: [:index, :show] do
    collection do
      get :autocomplete
    end
    member do
      get :public
      post :hide
    end
  end

  # Boards
  controller :boards do
    get  "/board/index" => :show
    get  "/board" => :show
    post "/board" => :create
  end

  # Accounts
  devise_for :account, path: "compte", controllers: {
    registrations: "registrations"
  }, path_names: {
    sign_in: "connexion",
    sign_out: "deconnexion",
    sign_up: "inscription",
    unlock: "debloquage"
  }
  resource :stylesheet, only: [:create, :edit, :update, :destroy]

  # API
  scope :api do
    use_doorkeeper do
      skip_controllers :applications, :authorized_applications
    end
  end
  namespace :api do
    resources :applications
    resources :authorized_applications, only: [:destroy]
    namespace :v1 do
      get  "/me"    => "accounts#me"
      post "/board" => "board#create"
      post "/journaux" => "diary#create"
      post "/news" => "news#create"
    end
  end

  # Redaction
  get "/redaction" => "redaction#index"
  namespace :redaction do
    resources :news, except: [:new, :destroy] do
      collection { get :moderation }
      member do
        get "/revisions/:revision" => :revision, as: :revision
        post :submit
        post :followup
        post :erase
        post :reassign
        post :urgent
        post :cancel_urgent
        get :reorganize
        put :reorganized
      end
      resources :links, only: [:new]
      resources :paragraphs, only: [:create]
    end
    resources :links, only: [:create, :edit, :update] do
      member { post :unlock }
    end
    resources :paragraphs, only: [:show, :edit, :update] do
      member { post :unlock }
    end
  end

  # Moderation
  get "/moderation" => "moderation#index"
  namespace :moderation do
    resources :news, except: [:new, :create, :destroy] do
      member do
        post :accept
        post :refuse
        post :rewrite
        post :reset
        post :ppp
        get :vote
      end
    end
    resources :sondages, controller: "polls", as: "polls", except: [:new, :create, :destroy] do
      member do
        post :refuse
        post :accept
        post :ppp
      end
    end
    resources :plonk, only: [:create]
    resources :block, only: [:create]
    resources :images, only: [:index, :destroy]
    resources :tags, only: [:index]
  end

  # Admin
  get "/admin"       => "admin#index"
  get "/admin/debug" => "admin#debug"
  namespace :admin do
    resources :comptes, controller: "accounts", as: "accounts", only: [:index, :update, :destroy] do
      resource :moderator, only: [:create, :destroy]
      resource :editor, only: [:create, :destroy]
      resource :admin, only: [:create, :destroy]
      member do
        post :password
        post :karma
      end
    end
    resources :reponses, controller: "responses", as: "responses", except: [:show]
    resources :sections, except: [:show]
    resources :forums, except: [:show] do
      member do
        post :archive
        post :reopen
        post :lower
        post :higher
      end
    end
    resources :categories, except: [:show]
    resources :bannieres, controller: "banners", as: "banners", except: [:show]
    resource :logo, only: [:show, :create]
    resource :stylesheet, only: [:show, :create]
    resources :sites_amis, controller: "friend_sites", as: "friend_sites", except: [:show] do
      member do
        post :lower
        post :higher
      end
    end
    resources :pages, except: [:show]
    resources :applications, except: [:new, :create]
  end

  # Search
  get "/recherche(/:type(/:facet))" => "search#index", as: :search

  # Statistics
  %i(tracker prizes users top moderation redaction contents comments tags applications anonymous collective).each do |action|
    get "/statistiques/#{action}", controller: :statistics, action: action
  end

  # Static pages
  controller :static do
    get "/proposer-un-contenu" => :submit_content, as: :submit_content
    get "/changelog" => :changelog, as: :changelog
    get "/:id" => :show, as: :static, constraints: { id: /[a-z_\-]+/ }
  end
end

app/models/wiki_page.rb
# encoding: UTF-8
# == Schema Information
#
# Table name: wiki_pages
#
#  id             :integer          not null, primary key
#  title          :string(100)      not null
#  cached_slug    :string(105)      not null
#  body           :text(4294967295)
#  created_at     :datetime
#  updated_at     :datetime
#  truncated_body :text(65535)
#

#
# The wiki have pages, with the content that can't go anywhere else.
#
class WikiPage < Content
  self.table_name = "wiki_pages"
  self.type = "Page wiki"

  RESERVED_WORDS = %w(index nouveau modifications pages)
  has_many :versions,
    -> { order(version: :desc) },
    class_name: "WikiVersion",
    dependent: :destroy,
    inverse_of: :wiki_page
  reserved = RESERVED_WORDS + RESERVED_WORDS.map(&:capitalize) + RESERVED_WORDS.map(&:upcase)
  validates :title, presence: { message: "Le titre est obligatoire" },
                    length: { maximum: 100, message: "Le titre est trop long" },
                    exclusion: { in: reserved, message: "Ce titre est réservé pour une page spéciale" }
  validates :body,  presence: { message: "Le corps est obligatoire" }

### SEO ###

  extend FriendlyId
  friendly_id :title, reserved_words: RESERVED_WORDS

### Hey, it's a wiki! ###

  attr_accessor :wiki_body, :message, :user_id

  wikify_attr :body
  truncate_attr :body

  after_save :create_new_version
  def create_new_version
    self.message = "révision n°#{versions.count + 1}" if message.blank?
    versions.create(user_id: user_id, body: wiki_body, message: message)
  end

### Associated node ###

  def create_node(attrs={})
    self.cc_licensed = true
    self.tmp_owner_id = user_id
    super
  end

### HomePage ###

  HomePage = "LinuxFr.org"
  def self.home_page
    find_by(title: HomePage)
  end

  def home_page?
    title == HomePage
  end

### ACL ###

  def creatable_by?(account)
    account.karma > Account.default_karma
  end

  def updatable_by?(account)
    account.karma > Account.default_karma
  end

  def destroyable_by?(account)
    account.amr?
  end

  def too_old_for_comments?
    false
  end

### Interest ###

  def self.interest_coefficient
    4
  end

end

app/controllers/wiki_pages_controller.rb
# encoding: UTF-8
class WikiPagesController < ApplicationController
  before_action :authenticate_account!, except: [:index, :show, :revision, :changes, :pages]
  before_action :load_wiki_page, only: [:edit, :update, :destroy, :revision]
  after_action  :marked_as_read, only: [:show], if: :account_signed_in?
  after_action  :expire_cache, only: [:create, :update, :destroy]
  caches_page   :index,   if: Proc.new { |c| c.request.format.atom? && c.request.ssl? && c.request.host == c.request.host.downcase }
  caches_page   :changes, if: Proc.new { |c| c.request.format.atom? && c.request.ssl? && c.request.host == c.request.host.downcase }
  respond_to    :html, :md

  def index
    respond_to do |wants|
      wants.html { redirect_to WikiPage.home_page }
      wants.atom { @wiki_pages = Node.public_listing(WikiPage, "created_at").map(&:content) }
    end
  end

  def show
    @wiki_page = WikiPage.find(params[:id])
    enforce_view_permission(@wiki_page)
    path = wiki_page_path(@wiki_page, format: params[:format])
    redirect_to path, status: 301 and return if request.path != path
    headers['Link'] = %(<#{wiki_page_url @wiki_page}>; rel="canonical")
    flash.now[:alert] = "Attention, cette page a été supprimée et n'est visible que par les admins" unless @wiki_page.visible?
    respond_with @wiki_page
  rescue ActiveRecord::RecordNotFound
    if current_account
      redirect_to new_wiki_page_url(title: params[:id])
    else
      render :not_found
    end
  end

  def new
    @wiki_page = WikiPage.new
    @wiki_page.title = params[:title]
    return not_enough_karma('pages de wiki') unless @wiki_page.creatable_by?(current_account)
    enforce_create_permission(@wiki_page)
  end

  def create
    @wiki_page = WikiPage.new
    @wiki_page.attributes = wiki_params :title
    @wiki_page.user_id = current_account.user_id
    return not_enough_karma('pages de wiki') unless @wiki_page.creatable_by?(current_account)
    enforce_create_permission(@wiki_page)
    if !preview_mode && @wiki_page.save
      redirect_to @wiki_page, notice: "Nouvelle page de wiki créée"
    else
      @wiki_page.node = Node.new
      @wiki_page.valid?
      render :new
    end
  end

  def edit
    @wiki_page.wiki_body = @wiki_page.versions.first.body
    return not_enough_karma('pages de wiki') unless @wiki_page.updatable_by?(current_account)
    enforce_update_permission(@wiki_page)
  end

  def update
    return not_enough_karma('pages de wiki') unless @wiki_page.updatable_by?(current_account)
    enforce_update_permission(@wiki_page)
    @wiki_page.attributes = wiki_params
    @wiki_page.user_id = current_account.user_id
    if !preview_mode && @wiki_page.save
      redirect_to @wiki_page, notice: "Modification enregistrée"
    else
      flash.now[:alert] = "Impossible d'enregistrer cette page de wiki" if @wiki_page.invalid?
      render :edit
    end
  end

  def destroy
    enforce_destroy_permission(@wiki_page)
    @wiki_page.mark_as_deleted
    redirect_to WikiPage.home_page, notice: "Page de wiki supprimée"
  end

  def revision
    @dont_index = true
    enforce_view_permission(@wiki_page)
    @version = @wiki_page.versions.find_by_version!(params[:revision])
    previous = @version.higher_item
    @was     = previous ? previous.body : ''
  end

  def changes
    @dont_index = true
    @versions = WikiVersion.order("created_at DESC")
                           .joins(:node)
                           .where("nodes.public" => true)
                           .page(params[:page])
    respond_to do |wants|
      wants.html
      wants.atom
    end
  end

  def pages
    @order = params[:order]
    @order = "created_at" unless VALID_ORDERS.include?(@order)
    @nodes = Node.public_listing(WikiPage, @order).page(params[:page])
  end

protected

  def wiki_params(*more)
    params.require(:wiki_page).permit(:wiki_body, :message, *more)
  end

  def marked_as_read
    current_account.read(@wiki_page.node) if @wiki_page.try(:node)
  end

  def load_wiki_page
    @wiki_page = WikiPage.find(params[:id])
  end

  def expire_cache
    return if @wiki_page.new_record?
    expire_page action: :index,   format: :atom
    expire_page action: :changes, format: :atom
  end
end

app/views/wiki_pages/_changes_box.html.haml
#changes.box
  %h1
    Wiki
  %ul
    %li= link_to "Afficher la liste des pages du wiki", "/wiki/pages"
    %li= link_to "Afficher les dernières modifications du wiki", "/wiki/modifications"

app/views/wiki_pages/_edition.html.haml
#wiki_edition.box
  %h1
    Éditions
  %p
    = link_to "Éditer", "/wiki/#{edition.to_param}/modifier"
  %p
    Modifié le
    = l edition.versions.first.created_at.to_date
  %p
    Les dernières modifications&nbsp;:
  %ul
    = list_of(edition.versions) do |v|
      = link_to "#{v.author_name}&nbsp;: #{v.message}".html_safe, "/wiki/#{edition.to_param}/revisions/#{v.version}"

app/views/wiki_pages/_form.html.haml
%p
  = form.label :wiki_body, "Contenu"
  = form.text_area :wiki_body, required: 'required', spellcheck: 'true', class: 'markItUp'
%p
  = form.label :message, "Log des modifications"
  = form.text_field :message, autocomplete: 'off', spellcheck: 'true', maxlength: 250, size: 80
%p
  = form.submit "Prévisualiser", id: "wiki_preview"
  = form.submit (form.object.new_record? ? "Créer" : "Mettre à jour") if @preview_mode

app/views/wiki_pages/_preview.html.haml
= article_for preview do |c|
  - c.meta  = ""
  - c.title = "#{link_to "Wiki", "/wiki", class: "topic"} #{spellcheck h preview.title}".html_safe
  - c.body  = spellcheck(preview.body)

app/views/wiki_pages/_wiki_page.html.haml
= article_for wiki_page do |c|
  - c.meta  = ""
  - c.title = "#{link_to "Wiki", "/wiki", class: "topic"} #{link_to wiki_page.title, wiki_page}".html_safe
  - if current_account && current_account.can_update?(wiki_page)
    - c.actions = link_to("Modifier", "/wiki/#{wiki_page.to_param}/modifier", class: 'action')

app/views/wiki_pages/changes.html.haml
%main#contents(role="main")
  =h1 "Les derniers changements sur le wiki"
  - feed "Flux Atom des derniers changements du wiki"

  %nav.toolbox
    = paginate @versions
  %ul.changes
    = list_of(@versions) do |v|
      #{l v.created_at.to_date} -
      = link_to v.wiki_page.title, v.wiki_page
      = link_to "(révision #{v.version} par #{v.user.try :name})", revision_wiki_page_path(v.wiki_page.cached_slug, v.version)
  %nav.toolbox
    = paginate @versions

app/views/wiki_pages/edit.html.haml
%main#contents(role="main")
  =h1 "Modifier une page de wiki"

  = render "preview", preview: @wiki_page if @preview_mode

  = form_for @wiki_page do |form|
    = messages_on_error @wiki_page
    = render form

  - if current_account && current_account.can_destroy?(@wiki_page)
    = button_to "Supprimer", [@wiki_page], method: :delete, data: { confirm: "Êtes-vous sûr de vouloir supprimer cette page de wiki ?" }, class: "delete_button"

  = render 'shared/wiki_help'

app/views/wiki_pages/new.html.haml
%main#contents(role="main")
  =h1 "Créer une page de wiki"

  %p
    Des <a href="/regles_de_moderation">règles de modération</a> sont applicables aux pages wiki (et au reste du site).

  = render "preview", preview: @wiki_page if @preview_mode

  = form_for @wiki_page do |form|
    = messages_on_error @wiki_page
    %p
      = form.label :title, "Titre"
      = form.text_field :title, autocomplete: 'off', required: 'required', spellcheck: 'true', maxlength: 100
    = render form

  = render 'shared/wiki_help'

app/views/wiki_pages/not_found.html.haml
%main#contents(role="main")
  =h1 "Page de wiki absente"

  %p
    Cette page de wiki n'existe pas. Si vous souhaitez la créer, vous devez d'abord vous identifier.

app/views/wiki_pages/pages.html.haml
=h1 "Les pages du wiki"
- feed "Flux Atom du wiki", "/wiki.atom"
- new_content_link = link_to("Écrire une page de wiki", "/wiki/nouveau") if current_account
= paginated_nodes @nodes, new_content_link

app/views/wiki_pages/revision.html.haml
%main#contents(role="main")
  - if !@wiki_page.visible?
    .alert
      %strong Cette page a été supprimée.

  - if @version.higher_item || @version.lower_item
    %nav
      %ul
        - if @version.higher_item
          %li= link_to "Précédente révision", revision_wiki_page_path(@wiki_page.friendly_id, @version.higher_item.version)
        - if @version.lower_item
          %li= link_to "Révision suivante", revision_wiki_page_path(@wiki_page.friendly_id, @version.lower_item.version)

  =h1 "Visualiser une révision"

  %h2
    = link_to @wiki_page.title, @wiki_page
  %h3
    #{@version.author_name}&nbsp;: #{@version.message} (#{l @version.created_at})
  %pre
    = htmldiff @was, @version.body

  - if @version.higher_item || @version.lower_item
    %nav
      %ul
        - if @version.higher_item
          %li= link_to "Précédente révision", revision_wiki_page_path(@wiki_page.cached_slug, @version.higher_item.version)
        - if @version.lower_item
          %li= link_to "Révision suivante", revision_wiki_page_path(@wiki_page.cached_slug, @version.lower_item.version)

app/views/wiki_pages/show.html.haml
- content_for :column do
  - if @wiki_page.home_page?
    = render 'changes_box'
  = render 'edition', edition: @wiki_page

%main#contents(role="main")
  - title @wiki_page.title
  - meta_for @wiki_page
  - if @wiki_page.home_page?
    - feed "Flux Atom du wiki", "/wiki.atom"

  = render @wiki_page
  = render @wiki_page.node

app/views/wiki_pages/show.md.erb
<%= render "nodes/front_matter", :content => @wiki_page %>

<%= raw @wiki_page.versions.first.body %>